*,
*::before,
*::after{
    box-sizing: border-box;
}
/* 
root matches the linked documents root element 
--ff- is a font family that you will link a font to
custom properties do require the double --
*/
:root{

    /* This is creating variables to be used in the rest of the styling sheet */

    --ff-primaryFont: 'Source Sans Pro', sans-serif;
    --ff-secondaryFont: 'Source Code Pro', monospace;

    /* -fw- is font weight */
    --fw-reg: 300;
    --fw-bold: 900;

    --colour-background: #23272a;
    --colour-text: #ffffff;
    --colour-accents: #2F4F4F;
    --colour-portfolioBackdrop: #2c2f33;
    --colour-portfolioText: #99aab5;

    /* fs is font size */
    --fs-h1: 3rem;
    --fs-h2: 2.25rem;
    --fs-h3: 1.25rem;
    --fs-body: 1rem;

    --boxShadow: 0.25em 0.25em 0.75em rgba(0,0,0,0.25);
}

/* 
    @media is ued in media queries to apply different styles for different media types/devices
*/

@media (min-width: 800px)
{
    :root{
        --fs-h1: 4.5rem;
        --fs-h2: 3.75rem;
        --fs-h3: 1.5rem;
        --fs-body: 1.125rem;
    }
}

/* General styles */

/* Scroll behavior allows for the website to smoothly transition between destinations */

html{
    scroll-behavior: smooth;
}

body{
    background: var(--colour-background);
    color: var(--colour-text);
    margin: 0;
    font-family: var(--ff-primaryFont);
    font-size: var(--fs-body);
    line-height: 1.6;
}
/* Padding is shifting content so that it does not touch the edges */
section{
    padding: 5em 2em;
}

img{
    display: block;
    max-width: 100%;
}

strong {font-weight: var(--fw-bold);}

/* Typography */

h1,h2,h3{
    line-height: 1;
    margin: 0;
}

h1{
    font-size: var(--fs-h1);
}
h2{
    font-size: var(--fs-h2);
}
h3{
    font-size: var(--fs-h3);
}

:focus{
    outline: 3px solid var(--colour-portfolioText);
    outline-offset: 3px;
}

/* 
    Each .section corresponds to the classes and sub classed that 
    I assigned in the backend section of the HTML doc
*/

.section_title{
    margin-bottom: 0.25em;
}

.section1_Title-HomePage{
    font-weight: var(--fw-reg);
}

.section1_Title-HomePage strong{
    display: block;
}

.section_subtitle{
    margin:0;
    font-size: var(--fs-h3);
}

.section2_Subheadding-aboutMe,
.section1_subtitle-HomePage{
    background: var(--colour-accents);
    padding: 00.25em 1em;
    font-family: var(--ff-secondaryFont);
    margin-bottom: 1em;
}

/* Navigation */
header{
    display: flex;
    justify-content: space-between;
    padding: 1em;
}

.webHeaderLogo{
    max-width: 150px;
}

.navigation{
    position:fixed;
    background: var(--colour-portfolioBackdrop);
    color: var(--colour-text);
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    z-index: 100;

    transform: translateX(100%);
    transition: transform 250ms cubic-bezier(0.5,0,0.5,1);
}

.navigationList{
    list-style: none;
    display: flex;
    height: 100%;
    flex-direction: column;
    justify-content: space-evenly;
    align-items: center;
    margin: 0;
    padding: 0;
}

.nav_link{
    color: inherit;
    font-weight: var(--fw-bold);
    font-size: var(--fs-h2);
    text-decoration: none;
}

.nav_link:hover{
    color: var(--colour-portfolioText);
}

/* Nav hamburger */

.navigationButton{
    padding: 0.5em;
    background: transparent;
    border: 0;
    cursor: pointer;
    position: absolute;
    right: 1em;
    top: 1em;
    z-index: 1000;
}

.navigation_open .navigation{
    transform: translate(0);
}

.navigation_open .navigationButton{
    position: fixed;
}

.navigation_open .hamburger {
    transform: rotate(.625turn);
}

.navigation_open .hamburger::before{
    transform: rotate(90deg) translate(-6px);
}

.navigation_open .hamburger::after{
    opacity: 0;
}

.hamburger{
    
    display: block;
    position: relative;
}

.hamburger,
.hamburger::before,
.hamburger::after{
    background: var(--colour-portfolioText);
    width: 2em;
    height: 3px;
    border-radius: 1em;
    transition: transform 250ms ease-in-out;
}

.hamburger::before,
.hamburger::after{
    /* pseudo elements do not work unless you give them content */
    content: '';
    position: absolute;
    left: 0;
    right: 0;
}

.hamburger::before{ top: 6px}
.hamburger::after{ bottom: 6px}

/* 
    Introduction section Layout
*/

.introductionSection{
    position: relative;
}

.home_image{
    box-shadow: var(--boxShadow);
}

@media (min-width: 600px)
{
    .introductionSection{
        /* Creates a grid display area for content */
        display: grid;
        width: min-content;
        margin: 0 auto;
        grid-column-gap: 1em;
        grid-template-areas: 
            "img title"
            "img subtitle";
        grid-template-columns: min-content max-content;
    }

    .home_image{
        grid-area: img;
        min-width: 250px;
        position: relative;
        /* z index is z position much like having priority layers in unity */
        z-index: 2;
    }

    .section1_subtitle-HomePage{
        align-self: start;
        grid-column: -1/1;
        grid-row: 2;
        text-align: right;
        /* position property specifies type of positioning method used for an element
            relative is just its position relative to its normal position
        */
        position: relative;
        left: -1.5em;
        width: calc(100% + 1.5em);
    }
}

/* My Proficiancies */

.work_button {
    display: inline-block;
    padding: 0.5em 2.5em;
    background: var(--colour-portfolioText);
    color: var(--colour-text);
    text-decoration: none;
    cursor: pointer;
    font-size: var(--fs-body);
    text-transform: uppercase;
    letter-spacing: 2px;
    font-weight: var(--fw-bold);
    transition: transform 200ms ease-in-out;
}

.work_button:hover{
    transform: scale(1.1);
}

.my_proficiencies{
    background: var(--colour-portfolioBackdrop);
    background-image: url(Images/ales-nesetril-Im7lZjxeLhg-unsplash.jpg);
    background-size: cover;
    background-blend-mode: multiply;
    color: var(--colour-text);
    text-align: center;
}

.my_proficiencies_title{
    color: var(--colour-portfolioText);
    position: relative;
}

.my_proficiencies_title::after{
    content: '';
    display: block;
    width: 2em;
    height: 1px;
    margin: 0.5em auto 1em;
    background: currentColor;
    opacity: 0.5;
}

.proficiencies{
    margin-bottom: 4em;
}

.proficiency{
    max-width: 500px;
    /* margin 0 auto keeps things centered if you set text alignment to centered */
    margin: 0 auto;
}


@media (min-width: 800px)
{
    .proficiencies{
        display: flex;
        max-width: 1000px;
        margin-left: auto;
        margin-right: auto;
    }
    /* The + checks if there is another type in the next position
    if so adds a margin to the left of the one that it found */
    .proficiency + .proficiency{
        margin-left: 2em;
    }
}

/* About me */

.aboutMe{
    /* margin 0 auto keeps things centered */
    max-width: 1000px;
    margin: 0 auto;
}

.aboutme_image{
    box-shadow: var(--boxShadow);
}

/* 
    min-width is the minimum width the content can be
*/

@media (min-width: 600px)
{
    .aboutMe{
        display: grid;
        /* Each coloumn is 200 px max width*/
        grid-template-columns: 1fr 200px;
        grid-template-areas: 
            "title img"
            "subtitle img"
            "text img";
        grid-column-gap: 2em;
    }

    .section2_Title-AboutMe{
        grid-area: title;
    }
    /* grid column 1/-1 stretches the element from one side to the other */
    .section2_Subheadding-aboutMe{
        grid-column: 1/-1;
        grid-row: 2;
        position: relative;
        left: -1em;
        width: calc(100% + 1em);
        padding-left: 1em;
        padding-right: 11em;
    }

    .aboutme_image{
        grid-area: img;
        position: relative;
        z-index: 2;
    }
}

/* portfolio */

.myWork{
    background-color: var(--colour-portfolioBackdrop);
    color: var(--colour-text);
    text-align: center;
}

.portfolio_subtitle{
    color: var(--colour-portfolioText);
    font-weight: var(--fw-bold);
    margin-bottom: 1em;
}

.portfolio{
    display: grid;
    /* repeat creates the amount of columns entered as first parameter */
    grid-template-columns: repeat(auto-fit, minmax(250px, 1fr));
}

.portfolio_item{
    background: var(--colour-accents);
    /* Whatever it would overlap with is now masked */
    overflow: hidden;
}

/* portfolio site animations */

.portfolio_img{
    transition: 
    transform 750ms cubic-bezier(0.5, 0, 0.5, 1),
    opacity 250ms linear;
}

.portfolio_item:focus{
    position: relative;
    z-index: 2;
}

/* Hover is the same as the unity event OnHover checks if mouse is hovering over the object */

.portfolio_img:hover,
.portfolio_item:focus .portfolio_img{
    transform: scale(1.2);
    opacity: 0.75;
}

/* Footer */

.footer{
    background: #111;
    color: var(--colour-portfolioText);
    text-align: center;
    padding: 2.5em;
    font-size: var(--fs-h3);
}

.footer a{
    color: inherit;
    text-decoration: none;
}

.footer-link{
    font-weight: var(--fw-bold);
}

.footer-link :hover,
.social-list_link :hover{
    opacity: 0.7;
}
/* text decoration is like rich text, adding under lines etc */
.footer-link:hover{
    text-decoration: underline;
}

/* Editing the list of social icons */
.social-list{
    /* takes away the bullet points */
    list-style: none;
    /* flex means flexible box which mkaes it easier to design flexible responsive layout structures */
    display: flex;
    justify-content: center;
    margin: 2em 0 0;
    padding: 0;
}

.social-list_item{
    margin: 0.5em;
}

.social-list_link{
    margin: 0.5em;
}



